#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <windows.h>
#include <stdbool.h>

bool running = false; //   
bool exit_flag = false; //  
int seconds = 0; //  

void print_time(int total_seconds) {
    int hours = total_seconds / 3600;
    int minutes = (total_seconds % 3600) / 60;
    int secs = total_seconds % 60;
    printf("\r : %02d:%02d:%02d\n", hours, minutes, secs);
    fflush(stdout); //    
}

DWORD WINAPI timer_thread(LPVOID lpParam) {
    while (!exit_flag) {
        if (running) {
            Sleep(1000);
            seconds++;
            print_time(seconds); //   
        }
    }
    return 0;
}

DWORD WINAPI control_thread(LPVOID lpParam) {
    char command;
    while (!exit_flag) {
        printf("\n  (s - , p - , r - , q - ): \n");
        scanf(" %c", &command);

        switch (command) {
        case 's':
            running = true;
            printf(" .\n");
            break;
        case 'p':
            running = false;
            printf("\n . ");
            print_time(seconds);
            printf("\n");
            break;
        case 'r':
            running = false;
            seconds = 0;
            printf("\n .\n");
            print_time(seconds);
            break;
        case 'q':
            running = false;
            exit_flag = true;
            printf("\n  .\n");
            break;
        default:
            printf("\n .\n");
            break;
        }
    }
    return 0;
}

int main() {
    system("chcp 1251 > null");
    HANDLE hTimerThread, hControlThread;

    //  
    hTimerThread = CreateThread(NULL, 0, timer_thread, NULL, 0, NULL);
    hControlThread = CreateThread(NULL, 0, control_thread, NULL, 0, NULL);

    //   
    WaitForSingleObject(hControlThread, INFINITE);
    exit_flag = true; //  
    WaitForSingleObject(hTimerThread, INFINITE);

    //   
    CloseHandle(hTimerThread);
    CloseHandle(hControlThread);

    printf(" .\n");
    return 0;
}